#include <iostream>

using namespace std;
typedef long long ll;
struct koordinate{
   ll x;//vrsta
   ll y;//kolona
};
void swaps(koordinate a,koordinate b){
    koordinate pom;
    pom=a;
    a=b;
    b=pom;
}
void sortiraj(koordinate a[],ll k){
   for(ll i=0;i<k-1;i++){
    for(ll j=i+1;j<k;j++){
        if(a[i].x>a[j].x) swaps(a[i],a[j]);
        else if(a[i].x==a[j].x) if(a[i].y>a[j].y) swaps(a[i],a[j]);
    }
   }

}

int main()
{
    ll n,m,k;
    cin >> n >> m >> k;
    koordinate a[k];
    for(int i=0;i<k;i++) cin >> a[i].x >> a[i].y;
    sortiraj(a,k);
    cout << 3 << '\n';//nemam vremena 
    return 0;
}